// 自作ページャー MkenPager
// 作者 Kenichi Matsumoto
// =============================================================================
var MkenPager = function(tagId, totalRow, viewCount){
	// ページャーの表示されるタグ
	this.tagId = tagId;
	// データの総件数
	this.totalRow = Number(totalRow);
	// 1ページに表示する件数
	this.viewCount = Number(viewCount);
	//	現在選択されているliのインデックス
	this.currentIdx = 0;
	//	現在選択されているページ番号
	this.currentPageNum = 1;
	//	現在選択されているページの先頭データの行番号
	this.currentPageTopRow = 1;
	// 最終ページ番号
	this.lastPageNum = Math.ceil(this.totalRow / this.viewCount);
};
// =============================================================================
// プロトタイプ定義（オブジェクト形式で）
MkenPager.prototype = {
// =============================================================================
// 各要素を生成
createHTML: function(){
	// ページャーを囲む枠
	var htmlStr = '<div id="' + this.tagId + 'Pager">';
	// 前へボタン(子の空のdivは三角)
	htmlStr += '<div id="' + this.tagId + 'Prev"><div></div></div>';
	// マイナスボタン(中央部のページを10件マイナスする)
	htmlStr += '<div id="' + this.tagId + 'Minus">－</div>';	
	// ページ表示部
	htmlStr += '<ul id="' + this.tagId + 'PageNumGroup">';
	// ページ番号を作成
	var tmpTotalRow = this.totalRow;
	for(var pageNum = 1; pageNum <= 10; pageNum++){	// liの数は10個で固定
		if(tmpTotalRow > 0){
			if(pageNum === 10){
				htmlStr += '<li>' + this.lastPageNum + '</li>';
			}else{
				htmlStr += '<li>' + pageNum + '</li>';
			}
		}else{
			htmlStr += '<li class="' + this.tagId + 'nonePage">&nbsp;</li>';
		}
		tmpTotalRow = tmpTotalRow - this.viewCount; 
	}
	htmlStr += '</ul>';
	// プラスボタン(中央部のページを10件プラスする)
	htmlStr += '<div id="' + this.tagId + 'Plus">＋</div>';
	// 次へボタン(子の空のdivは三角)
	htmlStr += '<div id="' + this.tagId + 'Next"><div></div></div>';
	htmlStr += '</div>';
	// フロートクリア
	htmlStr += '<div id="' + this.tagId + 'clear"></div>';
	
	document.getElementById(this.tagId).innerHTML = htmlStr;
},
//	スタイル設定 ------------------------------------------------------------------
setStyle: function(){
	// 全体を囲むdiv
	var pager = document.getElementById(this.tagId + 'Pager');
	pager.style.display = "flex";	// floatを使用しない場合
	pager.style.width = "447px";
	pager.style.height = "36px";
	pager.style.margin = "30px";
	pager.style.border = "1px solid rgba(0,128,128,0.5)";
	pager.style.borderRadius = "15px";
	// 前へボタン
	var prev = document.getElementById(this.tagId + 'Prev');
	prev.style.width = "26px";
	prev.style.height = "26px";
	prev.style.margin = "3px 20px";
	prev.style.borderRadius = "13px";
//	prev.style.float = "left";
	prev.style.backgroundColor = "#666666";
	prev.style.cursor = "default";
	prev.style.opacity = 0.5;
	// 前へボタンの三角
	var prevChild = prev.firstChild;
	prevChild.style.width = "0px";
	prevChild.style.height = "0px";
	prevChild.style.borderTop = "6px solid transparent";
	prevChild.style.borderRight = "10px solid #ffffff";
	prevChild.style.borderBottom = "6px solid transparent";
	prevChild.style.borderLeft = "10px solid transparent";
	prevChild.style.margin = "7px 0 0 -3px";
	// 次へボタン
	var next = document.getElementById(this.tagId + 'Next');
	next.style.width = "26px";
	next.style.height = "26px";
	next.style.margin = "3px 20px";
	next.style.borderRadius = "13px";
//	next.style.float = "left";
	next.style.backgroundColor = "#666666";
	next.style.cursor = "pointer";
	// 次へボタンの三角
	var nextChild = next.firstChild;
	nextChild.style.width = "0px";
	nextChild.style.height = "0px";
	nextChild.style.borderTop = "6px solid transparent";
	nextChild.style.borderRight = "10px solid transparent";
	nextChild.style.borderBottom = "6px solid transparent";
	nextChild.style.borderLeft = "10px solid #ffffff";
	nextChild.style.margin = "7px 0 0 9px";
	// マイナスボタン
	var minus = document.getElementById(this.tagId + 'Minus');
	minus.style.width = "23px";
	minus.style.height = "26px";
	minus.style.margin = "4px 0px";
//	minus.style.float = "left";
	minus.style.textAlign = "center";
	minus.style.color = "rgba(0,102,153,0.5)";
	minus.style.backgroundColor = "#eee";
	minus.style.fontWeight = "bold";
	minus.style.fontSize = "14px";
	minus.style.border = "1px solid rgba(0,128,128,0.5)";
	minus.style.cursor = "default";
	// プラスボタン
	var plus = document.getElementById(this.tagId + 'Plus');
	plus.style.width = "23px";
	plus.style.height = "26px";
	plus.style.margin = "4px 0px";
//	plus.style.float = "left";
	plus.style.textAlign = "center";
	plus.style.color = "rgba(0,102,153,0.5)";
	plus.style.backgroundColor = "#eee";
	plus.style.fontWeight = "bold";
	plus.style.fontSize = "14px";
	plus.style.border = "1px solid rgba(0,128,128,0.5)";
	if(this.lastPageNum < 11){
		plus.style.cursor = "default";
	}else{
		plus.style.cursor = "pointer";
	}
	// 中央部のUL（ページ番号のコンテナ）
	var pageNumGroup = document.getElementById(this.tagId + "PageNumGroup");
	pageNumGroup.style.width = "271px";
	pageNumGroup.style.height = "26px";
	pageNumGroup.style.margin = "4px 0";
	pageNumGroup.style.textAlign = "center";
	pageNumGroup.style.fontSize = "13px";
//	pageNumGroup.style.float = "left";
	// ul内のli （ページ番号部）
	var nodes = pageNumGroup.childNodes;
	for(var i = 0; i < nodes.length; i++){
		nodes[i].style.display = "inline-block";
		nodes[i].style.width = "23px";
		nodes[i].style.height = "26px";
		nodes[i].style.margin = "0 1px";
		nodes[i].style.paddingTop = "1px";
		nodes[i].style.border = "1px solid rgba(0,128,128,0.5)";
		nodes[i].style.color = "#006699";
		if(i === 0){
			nodes[i].style.cursor = "default";
			nodes[i].style.backgroundColor = "rgba(130,210,253,0.5)";
		}else{
			nodes[i].style.cursor = "pointer";
			nodes[i].style.backgroundColor = "rgba(130,210,253,0.1)";
		}
	}
	// 1ページ目と最終ページを外側にずらす
	nodes[0].style.marginRight = "5px";
	nodes[9].style.marginLeft = "5px";
	// ページが無い部分のスタイル
	var nonePage = document.getElementsByClassName(this.tagId + "nonePage");
	for(var i = 0; i < nonePage.length; i++){
		nonePage[i].style.borderColor = "#eeeeee";
		nonePage[i].style.cursor = "default";
	}
	// フロートクリア用div
//	var floatClear = document.querySelector("#" + this.tagId + "clear");
//	floatClear.style.width = 0;
//	floatClear.style.height = 0;
//	floatClear.style.display = "none";
//	floatClear.style.clear = "both";
},
// イベント登録 ------------------------------------------------------------------
setEvent: function(){
	// イベントのthisはインスタンスではなくイベントの発生元を指すので
	// インスタンスは一旦ローカル変数に代入して使用する
	var self = this;
	if(self.lastPageNum > 10){var lastIdx = 9;}		// ページ番号用liの最後のIndex
	var prev = document.getElementById(this.tagId + 'Prev');
	var next = document.getElementById(this.tagId + 'Next');
	var minus = document.getElementById(this.tagId + 'Minus');
	var plus = document.getElementById(this.tagId + 'Plus');
	var pageNumGroup = document.getElementById(this.tagId + "PageNumGroup");

	var nodes = pageNumGroup.childNodes;
	// ページ番号クリック **********
	for(var i = 0; i < nodes.length; i++){
		this.addListener(nodes[i], "click", function(){
			// クリックされたインデックスを取得
			var count = 0;
			var node = this;
			// 直前の兄弟がある限りカウンターを増やすことで自分が何番目かがわかる
			while(node.previousSibling) {
				++count;
				node = node.previousSibling;
			}
			
			var oldIdx = self.currentIdx;	// 直前のliインデックス
			self.currentIdx = count;
		
			//==追加===============================================================
			// 先頭ページの場合、中央のページ番号部分を先頭ページ側に寄せる
			if(self.currentIdx === 0){
				 for(var j = 1; j <= 8; j++){
					  nodes[j].childNodes[0].nodeValue = j + 1;
				 }
			}
			// 最終ページの場合、中央のページ番号部分を最終ページ側に寄せる
			if(self.currentIdx === 9){
				 var k = 8;
				 for(var j = 1; j <= 8; j++){
					  nodes[j].childNodes[0].nodeValue = self.lastPageNum - k;
					  k--;
				 }
			}
			//=====================================================================
			
			// ページ番号のstyleを元に戻す
			self.defaultPageStyle(nodes[oldIdx]);
			// クリックされたページ番号のstyleを変える
			self.newPageStyle(this);

			// 現在のページ番号を取得
			getPageNum(this);
			// 先頭データ行番号を取得
			getTopRowNum();
			// ボタンスタイル変更
			self.btnStyle(self.currentIdx);
		});
	}

	// 前へボタンクリック **********
	this.addListener(prev, 'click', function(){
		if(self.currentIdx === 0){	// 先頭インデックスの時は何もしない
			return;
		}else{
			// ページ番号のstyleを元に戻す
			self.defaultPageStyle(nodes[self.currentIdx]);
			
			var pageNum8 = Number(nodes[8].childNodes[0].nodeValue);

			// ２番目のインデックスの時、先頭ページとのページ差が2ページ以上ある場合は
			// 先頭と最終を除いた中央部のliのページ番号を減らす
			if((self.currentIdx === 1) && ((self.currentPageNum - 1) >= 2)){
				for(var i = 1; i <= 8; i++){
					var pageNum = Number(nodes[i].childNodes[0].nodeValue);
					nodes[i].childNodes[0].nodeValue = pageNum - 1;
				}
			// 最終インデックスの時、その前のインデックスとのページ差が2ページ以上の場合は
			// 最終ページ側に中央部のliのページ番号を寄せる
			}else if((self.currentIdx === 9) && ((self.lastPageNum - pageNum8) >= 2)){
				var j = 0;
				for(var i = 8; i >= 1; i--){
					j++;
					nodes[i].childNodes[0].nodeValue = self.lastPageNum - j;
				}
				// インデックスを減らす
				self.currentIdx--;
			}else{
				// インデックスを減らす
				self.currentIdx--;
			}
			// ページ番号の新スタイル
			self.newPageStyle(nodes[self.currentIdx]);
			// 現在のページ番号を取得
			getPageNum(nodes[self.currentIdx]);
			// 先頭データ行番号を取得
			getTopRowNum();
		}
		// ボタンスタイル変更
		self.btnStyle(self.currentIdx);
		// プラスマイナスのカーソル変更
		self.plusMinusStyle();
	});

	// 次へボタンクリック **********
	this.addListener(next, 'click', function(){
		if(self.currentIdx === lastIdx){	// 最終インデックスの時は何もしない
			return;
		}else{
			// ページ番号のstyleを元に戻す
			self.defaultPageStyle(nodes[self.currentIdx]);
			
			var pageNum1 = Number(nodes[1].childNodes[0].nodeValue);
			
			// ９番目のインデックスの時、最終ページとのページ差が2ページ以上の場合は
			// 先頭と最終を除いた中央部のliのページ番号を増やす
			if((self.currentIdx === 8) && ((self.lastPageNum - self.currentPageNum) >= 2)){
				for(var i = 1; i <= 8; i++){
					var pageNum = Number(nodes[i].childNodes[0].nodeValue);
					nodes[i].childNodes[0].nodeValue = pageNum + 1;
				}
			// 先頭インデックスの時、その次のインデックスとのページ差が2ページ以上ある場合は
			// 先頭ページ側に中央部のliのページ番号を寄せる
			}else if((self.currentIdx === 0) && ((pageNum1 - 1) >= 2)){
				for(var i = 1; i <= 8; i++){
					nodes[i].childNodes[0].nodeValue = i + 1;
				}
				// インデックスを増やす
				self.currentIdx++;
			}else{
				// インデックスを増やす
				self.currentIdx++;
			}
			// ページ番号の新スタイル
			self.newPageStyle(nodes[self.currentIdx]);
			// 現在のページ番号を取得
			getPageNum(nodes[self.currentIdx]);
			// 先頭データ行番号を取得
			getTopRowNum();
		}
		// ボタンスタイル変更
		self.btnStyle(self.currentIdx);
		// プラスマイナスのカーソル変更
		self.plusMinusStyle();
	});

	// マイナスボタンクリック **********
	this.addListener(minus, 'click', function(){
		var node1Val = Number(nodes[1].childNodes[0].nodeValue);
		// 2番目のページ番号から10を差し引いた結果が2ページ未満の場合
		if((node1Val - 10) < 2){
			// 3ページから11ページならば中央部のページ番号を1ページ側にずらす
			if(node1Val > 2 && node1Val < (2 + 10)){
				for(var i = 1; i <= 8; i++){
					var pageNum = Number(nodes[i].childNodes[0].nodeValue);
					nodes[i].childNodes[0].nodeValue = pageNum - (node1Val - 2);
				}
			// それ以外は何もしない
			}else{
				return;
			}
		}else{
			// 最初と最後を除いた中央部のliのページ番号を10づつ減らす
			for(var i = 1; i <= 8; i++){
				var pageNum = Number(nodes[i].childNodes[0].nodeValue);
				nodes[i].childNodes[0].nodeValue = pageNum - 10;
			}
		}
		// 現在のページ番号を取得
		getPageNum(nodes[self.currentIdx]);
		// 先頭データ行番号を取得
		getTopRowNum();
		// プラスマイナスのカーソル変更
		self.plusMinusStyle();
	});

	// プラスボタンクリック **********
	this.addListener(plus, 'click', function(){
		var node8Val = Number(nodes[8].childNodes[0].nodeValue);
		// ページ数が10に満たない場合
		if(lastIdx < 9){
			return;
		}
		// 9番目のページ番号に10を足した結果が最後から１ページ前のページ番号を超える場合
		if((node8Val + 10) > (self.lastPageNum - 1)){
			// 9番目のページ番号が（最終ページ番号－10）から（最終ページ－2）の間ならば中央部のページ番号を最終ページ側にずらす
			if(node8Val >= (self.lastPageNum - 10) && node8Val <= (self.lastPageNum -2)){
				for(var i = 1; i <= 8; i++){
					var pageNum = Number(nodes[i].childNodes[0].nodeValue);
					nodes[i].childNodes[0].nodeValue = pageNum + ((self.lastPageNum - 1) - node8Val);
				}
			// それ以外は何もしない
			}else{
				return;
			}
		}else{
			// 最初と最後を除いた中央部のliのページ番号を10づつ増やす
			for(var i = 1; i <= 8; i++){
				var pageNum = Number(nodes[i].childNodes[0].nodeValue);
				nodes[i].childNodes[0].nodeValue = pageNum + 10;
			}
		}
		// 現在のページ番号を取得
		getPageNum(nodes[self.currentIdx]);
		// 先頭データ行番号を取得
		getTopRowNum();
		// プラスマイナスのカーソル変更
		self.plusMinusStyle();
	});

	// 関数：現在のページ番号を取得
	function getPageNum(node) {
		var txtNode = node.childNodes[0];
		self.currentPageNum = Number(txtNode.nodeValue);
	}
	// 関数：先頭データ行番号を取得
	function getTopRowNum() {
		self.currentPageTopRow = (self.currentPageNum - 1) * self.viewCount + 1;
	}
},
//	既定のページ番号のスタイル ----------------------------------------------------
defaultPageStyle: function(node) {
	node.style.cursor = "pointer";
	node.style.backgroundColor = "rgba(130,210,253,0.1)";
},
// 新たに適用するページ番号のスタイル --------------------------------------------
newPageStyle: function(node) {
	node.style.cursor = "default";
	node.style.backgroundColor = "rgba(130,210,253,0.5)";
},
// ボタンスタイル変更 ------------------------------------------------------------
btnStyle: function(currentIdx) {
	var prev = document.getElementById(this.tagId + 'Prev');
	var next = document.getElementById(this.tagId + 'Next');
	if(currentIdx === 0){
		prev.style.cursor = "default";
		prev.style.opacity = 0.5;
		next.style.cursor = "pointer";
		next.style.opacity = 1;
	}
	if(currentIdx > 0 && currentIdx < 10){
		prev.style.cursor = "pointer";
		prev.style.opacity = 1;
		next.style.cursor = "pointer";
		next.style.opacity = 1;
	}
	if(currentIdx === 9){
		prev.style.cursor = "pointer";
		prev.style.opacity = 1;
		next.style.cursor = "default";
		next.style.opacity = 0.5;
	}
},
// プラスマイナスのカーソル変更 --------------------------------------------------
plusMinusStyle: function(){
	var minus = document.getElementById(this.tagId + 'Minus');
	var plus = document.getElementById(this.tagId + 'Plus');

	var pageNumGroup = document.getElementById(this.tagId + "PageNumGroup");
	var nodes = pageNumGroup.childNodes;
	var node1 = Number(nodes[1].childNodes[0].nodeValue);
	var node8 = Number(nodes[8].childNodes[0].nodeValue);
	var node9 = Number(nodes[9].childNodes[0].nodeValue);
	if(node1 - 1 === 1){
		minus.style.cursor = "default";
	}else{
		minus.style.cursor = "pointer";
	}
	if(node9 - node8 === 1){
		plus.style.cursor = "default";
	}else{
		plus.style.cursor = "pointer";
	}
},
// -----------------------------------------------------------------------------
addListener: function(elm, ev, listener){
	if(elm.addEventListener) {		// IE以外
		elm.addEventListener(ev, listener, false);
	} else if(elm.attachEvent) {	// IE
		elm.attachEvent('on' + ev, listener);
	} else {
		throw new Error('イベントリスナーに未対応です。');
	}
},
// -----------------------------------------------------------------------------
showPager: function(){
	this.createHTML();	// 各要素を生成
	this.setStyle();		// スタイルをセット
	this.setEvent();		// イベントをセット
},
// 引数で指定したページにジャンプする --------------------------------------------
jumpPage: function(jumpPageNum){
	var pageNumGroup = document.getElementById(this.tagId + "PageNumGroup");
	var nodes = pageNumGroup.childNodes;
			
	var oldIdx = this.currentIdx;	// 直前のliインデックス
	// ページ番号のstyleを元に戻す
	this.defaultPageStyle(nodes[oldIdx]);

	if(jumpPageNum === 1){
		this.currentIdx = 0;
	}else if(jumpPageNum === this.lastPageNum){
		this.currentIdx = 9;
	}else if(jumpPageNum > 1 && jumpPageNum < 10) {
		// ページ番号埋め込み
		for(var i = 0; i <= 8; i++){
			nodes[i].childNodes[0].nodeValue = i + 1;
		}
		this.currentIdx = jumpPageNum - 1;
	}else if(jumpPageNum > (this.lastPageNum - 8) && jumpPageNum < this.lastPageNum) {
		// ページ番号埋め込み
		var j = 0;
		for(var i = 9; i <= 1; i--){
			nodes[i].childNodes[0].nodeValue = this.lastPageNum - j;
			j++;
		}
		this.currentIdx = 9 - (this.lastPageNum - jumpPageNum);
	}	else{
		// ページ番号埋め込み
		for(var i = 1; i <= 8; i++){
			nodes[i].childNodes[0].nodeValue = jumpPageNum + (i - 1);
		}
		this.currentIdx = 1;
	}
	// ジャンプページ番号の新スタイル
	this.newPageStyle(nodes[this.currentIdx]);
	// ボタンスタイル変更
	this.btnStyle(this.currentIdx);

	// 現在のページ番号を取得
	var txtNode = nodes[this.currentIdx].childNodes[0];
	this.currentPageNum = Number(txtNode.nodeValue);
	// 先頭データ行番号を取得
	this.currentPageTopRow = (this.currentPageNum - 1) * this.viewCount + 1;

}
// =============================================================================
};
